routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('clients','ClientsController',['except' => 'show']);
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Client.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Client extends Model
{
    const ESTADOS_CIVIS = [
      1 => 'Solteiro',
      2 => 'Casado',
      3 => 'Divorciado'
    ];

    const PESSOA_FISICA = 'fisica';
    const PESSOA_JURIDICA = 'juridica';

    protected $fillableGenaral = [
        'nome',
        'documento',
        'email',
        'telefone',
        'inadimplente',
    ];

    protected $fillableFisica = [
        'data_nasc',
        'sexo',
        'estado_civil',
        'deficiencia_fisica'
    ];

    protected $fillableJuridica = [
        'fantasia'
    ];


    public static function getPessoa($value)
    {
        return $value == Client::PESSOA_JURIDICA ? $value : Client::PESSOA_FISICA;
    }

    public function fill(array $attributes)
    {
        if (!$this->pessoa) {
            $this->pessoa = self::getPessoa(isset($attributes['pessoa']) ? $attributes['pessoa'] : null);
        }

        $this->setFillable();
        return parent::fill($attributes);
    }

    public function setFillable()
    {
        if($this->pessoa == self::PESSOA_FISICA) {
            $this->fillable(array_merge($this->fillableGenaral,$this->fillableFisica));
        }else {
            $this->fillable(array_merge($this->fillableGenaral,$this->fillableJuridica));
        }
    }

    public function getSexoFormattedAttribute()
    {
        return $this->sexo == 'm' ? 'Masculino' : 'Feminino';
    }

    public function setDocumentoAttribute($value)
    {
        $this->attributes['documento'] = preg_replace('/[^0-9]/', "", $value);
    }

    public function getDocumentoFormattedAttribute()
    {
        $string = $this->documento;

        if(!empty($string)) {
            if (strlen($string) == 11) {
                $string = preg_replace('/(\d{3})(\d{3})(\d{3})(\d{2})/','$1.$2.$3-$4', $string);
            }else{
                $string = preg_replace('/(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/','$1.$2.$3/$4-$5', $string);
            }

            return $string;
        }
    }

    public function getDataNascFormattedAttribute()
    {
        return $this->pessoa == self::PESSOA_FISICA ? (new \DateTime($this->data_nasc))
            ->format('d/m/y') : "";
    }
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/Http/Controllers/ClientsController.php
<?php

namespace App\Http\Controllers;

use App\Client;
use App\Http\Requests\ClientRequest;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Http\Request;

class ClientsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $clients = Client::all();
        return view('clients.index', compact('clients'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        $paramPessoa = $request->get('pessoa');
        $pessoa = Client::getPessoa($paramPessoa);

        return view('clients.create', compact('pessoa'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ClientRequest $request)
    {
        $data = $request->all();
        $data['pessoa'] = Client::getPessoa($request->get('pessoa'));
        $data['inadimplente'] = $request->has('inadimplente') ? true : false;
        Client::create($data);

        return redirect()->route('clients.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        if (!($client = Client::find($id))) {
            throw new ModelNotFoundException("Cliente não foi encontrado");
        }
        $pessoa = $client->pessoa;
        return view('clients.edit', compact('client','pessoa'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(ClientRequest $request, $id)
    {
        if (!($client = Client::find($id))) {
            throw new ModelNotFoundException("Cliente não foi encontrado");
        }

        $data = $request->all();
        $data['inadimplente'] = $request->has('inadimplente') ? true : false;
        $client->fill($data);
        $client->save();

        return redirect()->route('clients.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        if (!($client = Client::find($id))) {
            throw new ModelNotFoundException("Cliente não foi encontrado");
        }

        $client->delete();
        return redirect()->route('clients.index');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }
}

resources/views/clients/_form.blade.php
{!! Form::hidden('pessoa',$pessoa) !!}

<div class="form-group">
    {!! Form::label('nome', 'Nome') !!}
    {!! Form::text('nome', null, ['class' => 'form-control']) !!}
</div>

<div class="form-group">
    {!! Form::label('documento', $pessoa == \App\Client::PESSOA_JURIDICA ? 'CNPJ' : 'CPF' ) !!}
    {!! Form::text('documento', null, ['class' => 'form-control']) !!}
</div>

<div class="form-group">
    {!! Form::label('email', 'E-mail') !!}
    {!! Form::email('email', null, ['class' => 'form-control']) !!}
</div>

<div class="form-group">
    {!! Form::label('telefone', 'Telefone') !!}
    {!! Form::text('telefone', null, ['class' => 'form-control']) !!}
</div>

@if($pessoa == \App\Client::PESSOA_JURIDICA)
    <div class="form-group">
        {!! Form::label('fantasia', 'Fantasia') !!}
        {!! Form::text('fantasia', null, ['class' => 'form-control']) !!}
    </div>
@else

    <div class="form-group">
        {!! Form::label('estado_civil', 'Estado Civil') !!}
        {!! Form::select('estado_civil', array_merge([0 => 'selecione'], \App\Client::ESTADOS_CIVIS), null,['class' => 'form-control']) !!}
    </div>

    <div class="form-group">
        {!! Form::label('data_nasc', 'Data Nascimento') !!}
        {!! Form::date('data_nasc', null, ['class' => 'form-control']) !!}
    </div>

    <div class="radio">
        <label>
            {!! Form::radio('sexo', 'f', false ) !!} Feminino
        </label>
    </div>

    <div class="radio">
        <label>
            {!! Form::radio('sexo', 'm', true ) !!} Masculino
        </label>
    </div>

    <div class="form-group">
        {!! Form::label('deficiencia_fisica', 'Deficiência Fisica') !!}
        {!! Form::text('deficiencia_fisica', null, ['class' => 'form-control']) !!}
    </div>
@endif


<div class="checkbox">
    <label>
        {!! Form::checkbox('inadimplente', 'inadimplente') !!} Inadimplente?
    </label>
</div>

resources/views/clients/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
<div class="row">
    <h3>Novo Cliente</h3>
    <h4>{{ $pessoa == \App\Client::PESSOA_JURIDICA ? 'Pessoa Jurídica' : 'Pessoa Física' }}</h4>

    <a href="{{ route('clients.create',['pessoa' => \App\Client::PESSOA_FISICA]) }}">Pessoa Física</a> |
    <a href="{{ route('clients.create',['pessoa' => \App\Client::PESSOA_JURIDICA]) }}">Pessoa Jurídica</a>
    <br><br>

    @include('errors._errors_form')

    {!! Form::open(['route' => 'clients.store', 'class' => 'form']) !!}

        @include('clients._form')
        <div class="form-group">
            {!! Form::submit('Criar Cliente',['class' => 'btn btn-primary']) !!}
        </div>

    {!! Form::close() !!}
</div>
</div>
@endsection

resources/views/clients/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
<div class="row">
    <h3>Novo Cliente</h3>
    <h4>{{ $pessoa == \App\Client::PESSOA_JURIDICA ? 'Pessoa Jurídica' : 'Pessoa Física' }}</h4>

    @include('errors._errors_form')

    {!! Form::model($client,['route' => ['clients.update','client' => $client->id], 'class' => 'form', 'method' => 'PUT']) !!}

        @include('clients._form')
        <div class="form-group">
            {!! Form::submit('Alterar Cliente',['class' => 'btn btn-primary']) !!}
        </div>
    {!! Form::close() !!}
    </form>
</div>
</div>
@endsection

resources/views/clients/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <h3>Lista de Clientes</h3>
        <a class="btn btn-primary" href="{{ route('clients.create') }}">Novo Cliente</a>
    </div>
    <div class="row">
        <table class="table table-striped">
            <thead>
            <tr>
                <th>ID</th>
                <th>Nome</th>
                <th>CNPJ/CPF</th>
                <th>Data Nasc.</th>
                <th>E-mail</th>
                <th>Telefone</th>
                <th>Sexo</th>
                <th>Ação</th>
            </tr>
            </thead>
            <tbody>
            @foreach($clients as $client)
                <tr>
                    <td>{{ $client->id }}</td>
                    <td>{{ $client->nome }}</td>
                    <td>{{ $client->documento_formatted }}</td>
                    <td>{{ $client->data_nasc_formatted }}</td>
                    <td>{{ $client->email }}</td>
                    <td>{{ $client->telefone }}</td>
                    <td>{{ $client->sexo_formatted }}</td>
                    <td>
                        <ul class="list-inline list-small">
                            <li>
                                <a class="btn btn-link btn-link-small" href="{{ route('clients.edit', ['client' => $client->id]) }}">Editar</a>
                            </li>
                            <li>|</li>
                            <li>
                                <form method="POST" action="{{ route('clients.destroy', ['client' => $client->id]) }}">
                                    {{ csrf_field() }}
                                    {{ method_field('DELETE') }}
                                    <button class="btn btn-link btn-link-small" type="submit">Excluir</button>
                                </form>
                            </li>
                        </ul>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
</div>
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Dashboard</div>

                <div class="panel-body">
                    @if (session('status'))
                        <div class="alert alert-success">
                            {{ session('status') }}
                        </div>
                    @endif

                    You are logged in!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layout.blade.php
<html>
<head>
    <title>Laravel Validation - @yield('title')</title>
</head>
<body>
    <h1>Laravel - CRUD de Clients</h1>
    @yield('content')
</body>
</html>

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ app()->getLocale() }}">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
    <style type="text/css">
        .list-inline.list-small li{
            padding-right: 1px;
            padding-left: 1px;
        }
        .btn-link.btn-link-small {
            padding: 0;
        }
    </style>
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-default navbar-static-top">
            <div class="container">
                <div class="navbar-header">

                    <!-- Collapsed Hamburger -->
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#app-navbar-collapse">
                        <span class="sr-only">Toggle Navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>

                    <!-- Branding Image -->
                    <a class="navbar-brand" href="{{ url('/') }}">
                        {{ config('app.name', 'Laravel') }}
                    </a>
                </div>

                <div class="collapse navbar-collapse" id="app-navbar-collapse">
                    <!-- Left Side Of Navbar -->
                    <ul class="nav navbar-nav">
                        &nbsp;
                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="nav navbar-nav navbar-right">
                        <!-- Authentication Links -->
                        @if (Auth::guest())
                            <li><a href="{{ route('login') }}">Login</a></li>
                            <li><a href="{{ route('register') }}">Register</a></li>
                        @else
                            <li class="dropdown">
                                <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <ul class="dropdown-menu" role="menu">
                                    <li>
                                        <a href="{{ route('logout') }}"
                                            onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                            Logout
                                        </a>

                                        <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                            {{ csrf_field() }}
                                        </form>
                                    </li>
                                </ul>
                            </li>
                        @endif
                    </ul>
                </div>
            </div>
        </nav>

        @yield('content')
    </div>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}"></script>
</body>
</html>